From 2110fcf96c3b02bd638c1873e4e8edbeb7960362 Mon Sep 17 00:00:00 2001
From: Jana Librova <jcupova@redhat.com>
Date: Sep 04 2024 07:17:14 +0000
Subject: [PATCH 5/11] Fix review


---

diff --git a/plugins/builder/taskrepos.conf b/plugins/builder/taskrepos.conf
index 7769b2f..1fa3e61 100644
--- a/plugins/builder/taskrepos.conf
+++ b/plugins/builder/taskrepos.conf
@@ -7,6 +7,7 @@ email_template : From: %%(from_addr)s
     To: %%(recipient)s
     A yum repository for the %%(build)s of %%(nvr)s (task %%(task_id)s) is available at:
     %%(repodir)s/
+    %%(old_repodir_msg)s
 
     You can install the rpms locally by putting this .repo file in your /etc/yum.repos.d/ directory:
     %%(repofile)s
diff --git a/plugins/builder/taskrepos.py b/plugins/builder/taskrepos.py
index c4bfac1..1361062 100644
--- a/plugins/builder/taskrepos.py
+++ b/plugins/builder/taskrepos.py
@@ -6,7 +6,6 @@ import os
 import six
 import smtplib
 import subprocess
-import time
 
 import koji
 import koji.tasks
@@ -102,28 +101,13 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
         return arches
 
     def create_pkg_list(self, rpms, repodir, build=None):
-        remote_pi = koji.PathInfo(topdir=self.options.topdir)
+        remote_pi = koji.PathInfo(topdir='')
         dest_dirs = []
         pkglist = []
         for rpm in rpms:
-            if build:
-                # rpm is a dict of rpminfo
-                url = remote_pi.build(build) + '/' + remote_pi.rpm(rpm)
-                dest = joinpath(repodir, rpm['arch'])
-            else:
-                # rpm is a relative path under the work/ directory
-                taskdir, rpmname = rpm.split('/')[-2:]
-                url = joinpath(remote_pi.work(), rpm).replace(self.options.topdir, '', 1)
-                rpminfo = self.session.getRPM(rpmname)
-                count = 0
-                while rpminfo is None and count != 20:
-                    time.sleep(2)
-                    rpminfo = self.session.getRPM(rpmname)
-                    count += 1
-                if rpminfo['arch'] != 'src':
-                    dest = joinpath(repodir, rpminfo['arch'])
-                else:
-                    continue
+            url = joinpath(remote_pi.work(), rpm)
+            arch = rpm.split('.')[-2]
+            dest = joinpath(repodir, arch)
             if dest not in dest_dirs:
                 dest_dirs.append(dest)
             pkglist.append(url)
@@ -132,31 +116,31 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
             os.symlink(koji.pathinfo.topdir, joinpath(dest_dir, 'toplink'))
             with open(joinpath(dest_dir, 'pkglist'), 'w') as dd:
                 for pkg in pkglist:
-                    dd.write(pkg)
+                    dd.write(f'{pkg}\n')
             with open(joinpath(dest_dir, 'pkglist'), 'r') as dd:
                 for line in dd:
                     self.logger.info('PkgLINE %s' % line)
         return dest_dirs
 
     def create_repos(self, taskinfo):
-        builds = self.session.listBuilds(taskID=taskinfo['id'])
+        builds = self.session.listBuilds(taskID=taskinfo['parent'])
         build = None
         if builds:
-            info = builds[0]
-            rpms = self.session.listRPMs(buildID=info['build_id'])
+            build = builds[0]
             repotype = 'official'
         else:
-            info = None
-            rpms = []
-            results = self.session.getTaskResult(taskinfo['id'])
-            if results.get('srpms'):
-                rpms.append(results['srpms'][0])
-                srpmname = os.path.basename(results['srpms'][0])
-                info = koji.parse_NVRA(srpmname)
-            rpms.extend(results['rpms'])
-            if info is None:
-                raise koji.GenericError("SRPM is missing.")
             repotype = 'scratch'
+        info = None
+        rpms = []
+        results = self.session.getTaskResult(taskinfo['id'])
+        if results.get('srpms'):
+            srpm = results['srpms'][0]
+            srpmname = os.path.basename(results['srpms'][0])
+            info = koji.parse_NVRA(srpmname)
+        if info is None:
+            raise koji.GenericError("SRPM is missing.")
+        if results.get('rpms'):
+            rpms.extend(results['rpms'])
         repodir = joinpath(self.workdir, info['name'], info['version'], info['release'])
         repodir_nvr = joinpath(repotype, info['name'], info['version'], info['release'])
         nvr = '%s-%s-%s' % (info['name'], info['version'], info['release'])
@@ -164,6 +148,7 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
         koji.ensuredir(repodir)
 
         self.create_pkg_list(rpms, repodir, build=build)
+        rpms.append(srpm)
         for arch in self.build_arches(rpms):
             self.gen_repodata(joinpath(repodir, arch))
         for arch in self.build_arches(rpms):
@@ -171,22 +156,17 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
         return repodir, repodir_nvr, nvr, repotype
 
     def write_repo_file(self, task, repodir, nvr, repotype):
-        if len(task['request']) > 2:
-            for tr in task['request']:
+        parent_taskinfo = self.session.getTaskInfo(task['parent'], request=True)
+        if len(parent_taskinfo['request']) > 2:
+            for tr in parent_taskinfo['request']:
                 if isinstance(tr, dict):
                     scratch = tr.get('scratch', False)
         else:
             scratch = False
-        subtasks = []
-        if task['method'] == 'createrepo':
-            subtasks = [subtask for subtask in task.getChildren(task['id'], request=True)]
-        repo_arches = []
-        for subtask in subtasks:
-            repo_arches.append('%s/%s' % (self.options.topurl, subtask["label"]))
         rpminfo = koji.parse_NVR(nvr)
         baseurl = joinpath(self.options.topurl, 'repos-tasks', repotype,
                            rpminfo['name'], rpminfo['version'], rpminfo['release'])
-        if 'noarch' in repo_arches:
+        if 'noarch' == task["label"]:
             baseurl = '%s/noarch/' % baseurl
         else:
             baseurl = '%s/%s/' % (baseurl, '$basearch')
@@ -259,7 +239,7 @@ module_hotfixes=1
         data['baseurl'] = self.write_repo_file(taskinfo, repodir, data['nvr'], repotype)
         repo_files, repos, repopath_part = self.upload_repo(repodir)
         data['owner'] = self.session.getUser(taskinfo['owner'])['name']
-        data['repo_urls'], uploadpath = self.session.taskRepoDone(
+        data['repo_urls'], uploadpath, data['old_repodir'] = self.session.taskRepoDone(
             self.id, repos, repodir_nvr, self.options.topurl, task_link)
         data['repodir'] = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr)
         self.session.host.tasksRepoNotifications(self.id, data)
@@ -293,6 +273,13 @@ class tasksRepoNotifications(BaseTaskHandler):
                 data['repofile'] = rf
             else:
                 data['repo_urls'] += '%s\n' % rf
+
+        if data['old_repodir']:
+            data['old_repodir_msg'] = (f"\nThis is latest version of repo. When you would like"
+                                       f" to use original version of repo, please use "
+                                       f"{data['old_repodir']}\n")
+        else:
+            data['old_repodir_msg'] = ''
         data['ticketlink'] = config['ticketlink']
         data['sourcecode'] = config['sourcecode']
         data['repolifetime'] = config['repo_lifetime']
diff --git a/plugins/hub/taskrepos_hub.py b/plugins/hub/taskrepos_hub.py
index 48ae2e1..33c9a72 100644
--- a/plugins/hub/taskrepos_hub.py
+++ b/plugins/hub/taskrepos_hub.py
@@ -19,34 +19,57 @@ __all__ = ('taskrepos', 'tasksRepoNotifications', 'taskRepoDone')
 logger = logging.getLogger('koji.hub')
 
 
+def recursive_walk(dirpath, repo_urls, topurl, task_link):
+    for root, dir, files in os.walk(dirpath):
+        if dir:
+            for subfolder in dir:
+                recursive_walk(subfolder, repo_urls, topurl, task_link)
+        if task_link:
+            folder_name_part = root[root.find('repos-tasks'):]
+        else:
+            folder_name_part = root[root.find('tasks'):]
+        for filename in files:
+            repo_urls.append(joinpath(topurl, folder_name_part, filename))
+    return repo_urls
+
+
 @export
 def taskRepoDone(task_id, repos, repodir_nvr, topurl, task_link):
     repo_urls = []
+    old_repodir = None
     nvr_dir = '/'.join(repodir_nvr.split('/')[1:]) + '/'
     for rp, fn in repos:
         src = joinpath(koji.pathinfo.work(), rp, fn).replace('/.', '/')
-        repostasks_dir = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr,
-                                  rp.split(nvr_dir)[1]).replace('/.', '/')
-        repostasks_file = joinpath(repostasks_dir, fn).replace('/.', '/')
-        koji.ensuredir(repostasks_dir)
+        task_dir = joinpath(koji.pathinfo.topdir, 'repos-tasks', 'tasks', str(task_id % 10000),
+                            str(task_id), rp.split(nvr_dir)[1]).replace('/.', '/')
+        taskfile = joinpath(task_dir, fn).replace('/.', '/')
+        koji.ensuredir(task_dir)
         if not os.path.exists(src):
             raise koji.GenericError("uploaded file missing: %s" % src)
-        safer_move(src, repostasks_file)
-        repo_urls.append(joinpath(topurl, 'repos-tasks', repodir_nvr,
-                                  rp.split(nvr_dir)[1], fn).replace('/.', '/'))
+        safer_move(src, taskfile)
+
     if task_link:
-        repodir = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr)
-        task_dir_with_id = joinpath(koji.pathinfo.topdir, 'tasks', str(task_id % 10000))
-        koji.ensuredir(task_dir_with_id)
-        dstdir = joinpath(task_dir_with_id, str(task_id))
-        if os.path.islink(dstdir) or os.path.isfile(dstdir):
-            os.remove(dstdir)
-        elif os.path.isdir(dstdir):
-            rmtree(dstdir)
-        os.symlink(repodir, dstdir)
+        task_dir_with_id = joinpath(
+            koji.pathinfo.topdir, 'repos-tasks', 'tasks', str(task_id % 10000), str(task_id))
+        reponvr_dir = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr)
+        koji.ensuredir(reponvr_dir)
+        if os.path.islink(reponvr_dir) or os.path.isfile(reponvr_dir):
+            old_repodir = os.readlink(reponvr_dir)
+            os.remove(reponvr_dir)
+        elif os.path.isdir(reponvr_dir):
+            rmtree(reponvr_dir)
+        os.symlink(task_dir_with_id, reponvr_dir)
+
+    if task_link:
+        files_dir = reponvr_dir
+    else:
+        files_dir = joinpath(
+            koji.pathinfo.topdir, 'repos-tasks', 'tasks', str(task_id % 10000), str(task_id))
+    repo_urls = recursive_walk(files_dir, repo_urls, topurl, task_link)
+
     shutil.rmtree(joinpath(
         koji.pathinfo.work(), '/'.join(rp.split(str(task_id))[:1]), str(task_id)))
-    return repo_urls, repostasks_dir
+    return repo_urls, files_dir, old_repodir
 
 
 @callback('postTaskStateChange')

